import Vue from 'vue';
import { IFormInputs, IDialogButtons, IVueDialog } from './types';

export default class Dialog {
    public show: boolean = false;
    public width: number = 320;
    public persistent: boolean | undefined = false;
    public bus: any = new Vue();
    public title: string | undefined;
    public message: string | undefined;
    public id: any;
    public dividerAction = false;
    public dividerHeader = false;
    public inputs: IFormInputs[];
    public buttons: Array<string | IDialogButtons>;
    public mClass: any[] = [];

    constructor() {
        this.id = null;
        this.title = undefined;
        this.message = undefined;
        this.inputs = [];
        this.buttons = [];
    }

    public create(data: IVueDialog) {
        this.persistent = data.persistent;
        this.title = data.title;
        this.message = data.message;
        this.width = data.width ? data.width : 300;
        this.inputs = data.inputs ? data.inputs : [];
        this.dividerHeader = data.dividerHeader ? data.dividerHeader : false;
        this.dividerAction = data.dividerAction ? data.dividerAction : false;
        this.buttons = data.buttons;
        this.mClass = data.class ? data.class : [];
    }
    public present() {
        this.show = true;
    }
    public addInput(input: IFormInputs) {
        const d = this.inputs.every((inp) => {
            return inp.name !== input.name;
        });
        if (d) {
            this.inputs.push(input);
        }
    }
    public delInput(name: string | null = null) {
        if (name === null) {
            this.inputs.pop();
        } else {
            this.inputs.forEach((v, ix) => {
                if (v.name === name) {
                    this.inputs.splice(ix, 1);
                    return true;
                }
            });
        }
    }
    public close() {
        this.show = false;
    }
}
